--- linux-user/syscall.c.orig	2004-09-13 22:41:04.000000000 +0100
+++ linux-user/syscall.c	2004-10-09 08:13:48.000000000 +0100
@@ -73,6 +73,18 @@
 #define USE_UID16
 #endif
 
+#if defined(TARGET_ARM)
+#define UNAME_MACHINE "armv4l"
+#elif defined(TARGET_I386)
+#define UNAME_MACHINE "i686"
+#elif defined(TARGET_PPC)
+#define UNAME_MACHINE "ppc"
+#elif defined(TARGET_SPARC)
+#define UNAME_MACHINE "sun4"
+#else
+#error unsupported CPU
+#endif
+
 //#include <linux/msdos_fs.h>
 #define	VFAT_IOCTL_READDIR_BOTH		_IOR('r', 1, struct dirent [2])
 #define	VFAT_IOCTL_READDIR_SHORT	_IOR('r', 2, struct dirent [2])
@@ -2391,7 +2403,6 @@
         ret = get_errno(setdomainname((const char *)arg1, arg2));
         break;
     case TARGET_NR_uname:
-        /* no need to transcode because we use the linux syscall */
         {
             struct new_utsname * buf;
     
@@ -2403,7 +2414,6 @@
                 strcpy (buf->machine, UNAME_MACHINE);
             }
         }
-        ret = get_errno(sys_uname((struct new_utsname *)arg1));
         break;
 #ifdef TARGET_I386
     case TARGET_NR_modify_ldt:
